 
/* Regroupement d'items de saisie dans les pages de type formulaire */

/* Regroupement sous forme de formulaire à 2 colonnes : label colonne de gauche gauche, champ de saisie colonne de droite */
.parameter-area {
    display:grid;
    grid-template-columns: 1fr 5fr;
    gap: 10px;
    padding-left: 2rem;
    margin-top: 10px;
}

/* Alignement à gauche pour les éléments 0, 2, 4... -> les labels de la colonne de gauche */
.parameter-area :nth-child(2n) {
    text-align: left;
}

/* "Case" utilisée pour la saisie des paramètres */
/*.ParameterCell {*/
.parameter-area--large-labels {
    grid-template-columns: 3fr 5fr;
}

.parameter-area--large-labels :nth-child(2n) {
    text-align: left;
}

/* Zone de saisie d'un texte sur plusieurs lignes */
.parameter-area textarea {
    width: 50rem;
    font-family: inherit;
}

/* Definition de la classe permettant de définir des tableaux de lignes */
.line-array {
    display: inline-block;
}

/* Zone de titre du tableau */
.line-array>:first-child {
    background-color: white;
    border: 1px solid grey;
    justify-content: flex-start;
}

/* définition d'une ligne du tableau */
.ui-flex-line {
    display: flex;
    flex-direction: row;
    background-color: var(--tableline-bg-color);
    justify-content: space-between;
    padding: 4px;
    border-radius: 6px;
    border: 1px solid white;
    margin: 3px;
}

.ui-flex-line input[type=text]:disabled {
    border-color: transparent;
    background-color: inherit;
    color:inherit;
}

.ui-flex-line input[type=text]:read-only {
    border-color: transparent;
    background-color: inherit;
    color:inherit;
}

.draggable-anchor {
    cursor: move;
    width: 4rem;
    text-align: center;
}

/* Définition des messages */

body.message-body {
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: center;
    width: 100%;
    height: 100vh;
}

.important-message {
    background-color: white;
    color: black;
    border: 2px solid rgb(0, 136, 255);
    border-radius: 12px;
    box-shadow: 5px 5px 15px rgba(0, 0, 0, 0.4);
    padding: 4rem;
    margin: 2rem;
    font-weight: bold;
    font-size: 1.5rem;
    width: 80%;
    max-width: 800px;
}

.important-message h1 {
    font-size: 2.5rem;
    text-align: center;
}

.important-message.waiting {
    /*padding-top: 2rem;
    padding-bottom: 2rem;*/
    display: flex;
    justify-content: flex-start;
    gap: 4rem;
    max-width: 100%;
}

.important-message.waiting>div {
    display: table;
}

.important-message.waiting>div>div {
    display: table-cell;
    vertical-align: middle;
    font-size: 2rem;
}

.important-message.waiting img {
    float: right;
}

/* Permet de définir un div comme une ligne */
.is-row {
    display: flex;
    flex-direction: row;
    column-gap: 1rem;
}

/* Permet de définir un div comme une colonne */
.is-column {
    display: flex;
    flex-direction: column;
    max-width: 40px;
    margin-left: 3px;
}

.navigation-bar {
    display: flex;
    flex-direction: row;
    padding-left: 3rem;
    padding-right: 3rem;
    padding-top: 0.5rem;
    padding-bottom: 1rem;
    font-size: 1.2rem;
    align-self: stretch;
    position: fixed;
    width: 100%;
    height: 2rem;
    bottom: 1rem;
    left: 0;
    background: var(--navigationbar-bg-color);
    border-radius: 12px 12px 0 0;
    text-align: center;
    justify-content: center;
}

.navigation-bar-page-data {
    background : white;
    border: 1px solid black;
    font-family: monospace;
}

.navigation-bar .ui-button {
    font-size: 1.2rem;
    display:table-cell;
    vertical-align: middle;
}

.navigation-bar-action-area {
    position:fixed;
    bottom: 2rem;                /* positionnement en bas de l'écran */
    right: 2rem;                 /* Positionnement à droite */
    z-index: 100;
    display: flex;
    flex-direction: row-reverse; /* ordre droite -> gauche */
    gap: 10px;                   /* espace régulier entre les icônes */
}

.navigation-bar-action-area .ui-button {
    text-shadow: none;
    border-radius: unset;
    padding: unset;
    background: transparent;
    box-shadow: unset;
}

.navigation-bar-action-area .ui-button:hover {
    background-color: transparent;
}

.navigation-bar-action-area .ui-button:active {
    background-color: transparent;
}

.navigation-bar-action-area .ui-button img {
    height: 2rem;
    width: auto;
}

.navigation-bar-header-area {
    position:fixed;
    bottom: 2rem;                /* positionnement en bas de l'écran */
    left: 2rem;                  /* Positionnement à gauche */
    z-index: 100;
    display: flex;
    flex-direction: row;         /* ordre gauche -> droite */
    gap: 10px;                   /* espace régulier entre les icônes */
}

.navigation-bar-header-area div {
    color: var(--main-fg-color);
    vertical-align: middle;
}

/* Zone principale d'affichage en mode formulaire */
.main-form-page-area {
    padding-left: 3rem;
    padding-top: 1rem;
    padding-bottom: 1rem;
    padding-right: 1rem;
}

.main-form-page-area textarea {
    font-family: inherit;
}

/* Panneau utilisé suivant le contexte de la page - typiquement en bas de page */
.context-panel {
    z-index: 5;
    background-color: darkgrey;
    background: rgba(0,0,0,0.5);
    border-radius: 12px 12px 0 0;
    color: lightgrey;
    border-top: 1px solid white;
    position: fixed;
    width: 100%;
    height: 1rem;
    bottom: 0;
    left: 0;
    text-align: center;
    transition: height 0.5s linear;
    transition-delay: 0.5s;
    &:hover {
        /*transform: scale(1.2);*/
        color: white;
        height: 20%;
        background: rgba(0,0,0,1);
    }
}
.context-panel-area {
    display: flex;
    flex-direction: row;
    margin-left: 4rem;
    margin-right: 4rem;
    justify-content: space-between;
}
.context-panel-area .ui-button img {
    height: 100px;
}

#menu-burger {
    position:fixed;
    bottom: 2rem;
    left: 2rem;
    z-index: 120;
    display: none;
}

#menu-burger:active~.main-menu-panel,
#menu-burger:active~.main-menu-panel:before {
    display: inline;
}

/* Panneau de menu à gauche */
.main-menu-panel{
    background: var(--left-menu-bg-color);
    border-radius: 0 12px 12px 0;
    color: lightgrey;
    position: fixed;
    left: 0;
    top: 0;
    height: 100%;
    width: 6px;
    z-index: 110;
    
    transition: width 0.5s linear;
    transition-delay: 0.5s;
    &:hover {
        color: white;
        width: 400px;
        background: var(--left-menu-bghover-color);
    }
}
.main-menu-container {
    display:flex;
    flex-direction: column;
    align-items: stretch;
    padding: 0 0rem 0 0rem;
    margin-left: 1rem;
    margin-right: 1rem;
}
.main-menu-container>* {
    align-self: stretch;
}
/* Découpage du menu en 3 parties */
.main-menu-container>*:first-child() {
    height: 10vh;
}
.main-menu-container>*:nth-child(0n+2) {
    height: 60vh;
}
.main-menu-container>*:last-child() {
    height: 30vh;
}
.main-menu-header {
    overflow:hidden;
    text-overflow: clip;
    white-space: nowrap;
    text-align: center;
    padding: 20px 0 0 0;
}
.main-menu-content {
    white-space: nowrap;
    padding: 2rem 0 0 0;
}
.main-menu-footer {
    overflow:hidden;
    text-overflow: clip;
    white-space: nowrap;
    text-align: center;
}
/* Menu en colonne */
.main-menu {
    display:flex;
    height: 100%;
    flex-direction: column;
    align-items: stretch;
}
.main-menu>* {
    color: #dcdcdc;
    font-size: 24px;
    text-align: center;
    transition-property: transform;
    transition-duration: 500ms;
    &:hover {
        color: white;
        transform: scale(1.15);
    }
}
/* Pas de grossissement sur la ligne de séparation en base de menu (3ème last child) */
.main-menu>*:nth-last-child(3) {
    transition-property: none;
    &:hover {
        transform: scale(1);
    }
}
/* Pas de grossissement sur l'image (2ème last child) + prise de l'espace restant */
.main-menu>*:last-child {
    height: 70%;
    transition-property: none;
    display:table;
    vertical-align: middle;
    &:hover {
        transform: scale(1);
    }
}
.main-menu>*:last-child div {
    height: 90%;
    display: table-cell;
    vertical-align: middle;
}
.main-menu a {
    color: #dcdcdc;
    text-decoration: none;
}
.main-menu .is-disabled a {
    color: grey;
    cursor: default;
    pointer-events: none;        
    text-decoration: none;
}

.main-menu>div {
    overflow: hidden;
    height: 52px;
}

.main-menu-logo {
    max-width: 30%;
    height: auto;
}

/* Menus déroulant du menu principal */
.main-menu .title-sub-menu {
    overflow: hidden;
    display:flex;
    flex-direction: column;
}
.main-menu .title-sub-menu :last-child {
    margin-bottom: 10px;
}
.main-menu .title-sub-menu:hover +.sub-menu {
    display: inline-block;
    overflow: visible;
}

.main-menu .sub-menu>* {
    &:hover {
        color: white;
        transform: scale(1.15);
    }
}

.main-menu .sub-menu {
    position: fixed;
    left:350px; /* Tenir compte du margin et padding */
    top: 5px;
    width: 300px;
    display: none;
    background-color: var(--titlesubmenu-bg-color);
    font-size: 16px;
    border: 1px solid white;
    border-radius: 12px
}
.main-menu .sub-menu:hover {
    display: inline-block;
}
.main-menu .title-sub-menu.is-empty {
    display:flex;
    flex-direction: column;
    color: grey;
    &:hover {
        color: grey;
        transform: scale(1);
    }
}
.main-menu .is-disabled {
    &:hover {
        transform: scale(1);
    }
}

.is-error {
    font-style: italic;
    font-weight: bold;
    color: red;
}

.important-message.is-error {
    border: 2px solid red;
}

.end-of-form-area {
    display: flex;
    flex-direction: row;
    justify-content: flex-end;
    column-gap: 1rem;
    width: 100%;
    position: fixed;
    right: 0px;
    bottom: 0px;
    padding: 10px;
    background: var(--bottom-bg-color);
    opacity: var(--bottom-bg-opacity);
    border-top: 1px solid black;
    border-radius: 12px 12px 0px 0px;
    z-index: 80;
}

/* Menus Pop-up */

.ui-pop-up-menu {
    display: none;
    flex-direction: column;
    position: fixed;
    margin: 2px;
    padding-bottom: 5px;
    border: 1px solid white;
    border-radius: 6px;
    background-color: var(--popupmenu-bg-color);
    max-height: 90%;
    max-width: 50%;
    z-index: 200;
    box-shadow: 5px 5px 15px rgba(0, 0, 0, 0.4);
}

.ui-pop-up-menu:first-child {
    flex: 0 1 auto;
}

.ui-pop-up-menu.is-visible {
    display: flex;
}

.ui-pop-up-menu > * {
    padding: 0 5px;
}

.ui-pop-up-menu > *:first-child {
  padding-top: 5px;
}

.ui-pop-up-menu-title {
    background: var(--titlepopupmenu-bg-color);
    color: var(--titlepopupmenu-fg-color);
    margin-bottom: 6px;
    border-bottom: 1px solid grey;
    border-radius: 6px 6px 0px 0px;
    text-align: center;
    font-weight: bold;
    padding-bottom: 6px;
    /*cursor: move;*/
}

/* Sous-menu d'un pop-up menu */
.ui-sub-menu {
    display: none;
    flex-direction: column;
    align-items: stretch;
    gap: 1px;
}

.ui-sub-menu.is-visible {
    display: flex;
}

.with-inputs {
    padding: 15px;
    border: 1px solid black;
    border-radius: 12px;
    margin: 10px
}

.with-inputs .ui-button {
    float: right;
}

.with-inputs input {
    width: 100%;
    box-sizing: border-box;
}

/* Liste incluses dans les pop-up menus */
.ui-list-in-pop-up-menu {
    background-color: white;
    overflow: auto;
    max-height: calc(90vh - 130px);
    border-radius: 6px;
    padding: 3px;
    margin-bottom: 5px;
}

.notify-menu-container {
    display: none;
    position: fixed; 
    top: 0; 
    bottom: 0; 
    left: 0rem; /* remplacer 0 pour laisser l'accès au main-menu-panel */
    right: 0;
    z-index: 150;
    background: rgb(0, 0, 0, 0.5);
}

.notify-menu {
    position: absolute;
    top: 15%; 
    left: 100px; 
    right: 100px;
    margin: 2px;
    border: 1px solid white;
    border-radius: 8px;
    background-color: var(--notifymenu-bg-color);
    box-shadow: 5px 5px 15px rgba(0, 0, 0, 0.4);
    height: auto;
    padding-bottom: 4px;
}

.notify-menu .is-row {
    margin-top: 1rem;
    padding-left: 4px;
    padding-right: 4px;
}

.notify-menu-title {
    background-color: whitesmoke;
    border-bottom: 1px solid white;
    border-radius: 8px 8px 0px 0px;
    color: black;
    text-align: center;
    height: auto;
    padding: 3px;
}

.notify-menu-container.is-error .notify-menu-title {
    background-color: red;
    color: white;
}

.notify-menu-container.confirmation .notify-menu-title {
    background-color: chocolate;
    color: white;
}
.notify-menu-container.confirmation .notify-menu-title {
    background-color: lightgreen;
}

.notify-menu-text {
    padding-top: 1rem;
    font-weight: bold;
    text-align: center;
    height: 2.5rem;
    color: black;
}

.notify-menu-container.confirmation .notify-menu-text {
    padding: 1rem 0.5rem 0rem 0.5rem;
    white-space: pre-line;
}

.notify-menu-inputs {
    padding: 1rem 0.5rem 0rem 0.5rem;
    font-weight: bold;
    text-align: center;
    min-height: 2.5rem;
    white-space: pre-line;
}

.field-line {
    display: grid;
    grid-template-columns: 2fr 4fr;
    gap: 10px;
}

.field-line label {
    text-align: left;
}

.ui-pop-up-menu .right-aligned {
    margin-top: 10px;
    margin-bottom: 5px;
    margin-right: 1rem;
    padding-right: 0px;
    padding-bottom: 0px;
    padding-top: 0px;
    position: relative;
    bottom: 0;
    left: auto;
    right: auto;
    border: 0px;
    background: inherit;
}

.img-with-text-button-container {
    position: relative;
    height: 28px;
    display: none;
    width: 99%;
}
.img-with-text-button-container.is-visible {
    display: flex;
}
.img-with-text-button-container.icon-only {
    max-width: 40px;
}
.img-with-text-button-container.icon-only.is-visible {
    display: block;
}
.img-with-text-button-container div {
    position: absolute;
    z-index: 1;
    left: 1rem;
}
.img-with-text-button-container  img {
    width: 28px;
    height: 28px;
}

.img-with-text-button-container .text-in-button-container {
    position: relative;
    top: 0px; 
    left: 2rem;
    width: 28px; 
    height: 28px; 
    z-index: 2;
    font-size: 2rem;
    color: white
}

.img-with-text-button-container .button-in-button-container {
    font-size: 2rem;
    margin: 0px;
    padding: 0px;
    background: transparent;
    border-width: 0;
    color: white;
    cursor: pointer;
    background-image: none;
    box-shadow: none;
}

.img-with-text-button-container .ui-button--option {
    margin-left: 2rem;
}

.active-only-for-edit:disabled {
    cursor: default;
}

/* Zones masquables en fonction valeur checkbox */
.maskable-area {
    position: absolute;
    top: 0;left: 100%;
    margin-left: 10px;
    border: 1px solid black;
    border-radius: 12px;
    background-color: var(--popupmenu-bg-color);
    display: none; /* affichée par callback sur la checkbox */
    padding: 0.5rem;
}
.maskable-area.visible-at-startup {
    left: 40%;
}
.included-in-maskable-area {
    border: 1px solid white;
    border-radius: 6px;
    background-color: var(--popupmenu-bg-color);
    display: none; /* affichée par callback sur la checkbox */
    padding: 0.5rem;
}
.maskable-area div {
    white-space: nowrap;
    margin-bottom: 2px;
}
.maskable-area .parameter-area {
    padding-left: 0px;
}

/* Styles pour les viewers de fichiers */
.modal {
  display: none;
  position: fixed;
  z-index: 9999;
  left: 0; top: 0; right: 0; bottom: 0;
  background-color: rgba(0,0,0,0.8);
  align-items: center;
  justify-content: center;
  overflow: auto;
}

.modal-content {
  position: relative;
  max-width: 90%;
  max-height: 90%;
}

.modal-content img {
  display: block;
  max-width: 100%;
  max-height: 100%;
  transform-origin: center center;
  transition: transform 0.2s;
}

.modal-controls {
  position: absolute;
  display: flex;
  flex-direction: row;
  top: 10px;
  right: 20px;
  z-index: 10000;
}

.viewer-button {
  width: 40px;
  height: 40px;
  margin: 5px;
  border-radius: 50%;
  border: 1px solid #ccc;
  background-color: rgba(255, 255, 255, 0.8);
  color: #333;
  font-size: 18px;
  cursor: pointer;
  display: flex;
  align-items: center;
  justify-content: center;
  transition: background-color 0.2s, transform 0.2s;
}

.viewer-button:hover {
  background-color: rgba(255, 255, 255, 1);
  transform: scale(1.1);
}
.viewer-content-pdf {
  width: 90vw; 
  height: 90vh; 
  border: none;
}
.viewer-content-text {
  background: white;
  width: 90vw;
  height: 90vh;
  border: none;
  padding: 0.5rem;
}

@media only screen and (min-resolution: 200dpi) and (orientation: portrait) {
    /* Mobile */
/*    img {
        width: 100px;
        height: auto;
    }*/
    h1 {
        font-size: 4rem;
     }
    h2 {
        font-size: 4rem;
    }
    .parameter-area textarea {
        width: 100%;
        height: 20rem;
        font-family: inherit;
    }

    .parameter-area {
        display:grid;
        grid-template-columns: 1fr;
        gap: 10px;
        font-size: 42px;
        margin-top: 10px;
    }
    .parameter-area input {
        font-size: 4rem;
    }
    .parameter-area textarea {
        font-size: 4rem;
    }
    .parameter-area select {
        font-size: 4rem;
    }
    .parameter-area--large-labels {
        display:flex;
        flex-direction: row;
        flex-wrap: wrap;
        padding-left: 1rem;
        padding-right: 1rem;
        /*font-size: 20px;*/
        /*border: 1px solid white;*/
    }
    .parameter-area--large-labels>:nth-child(2n+1) {
        min-width: 50%;
        max-width: 80%;
        padding-top: 1rem;
    } 
    .parameter-area--large-labels>:nth-child(2n) {
        min-width: 15%;
        margin-left: auto; /* Alignement du 2ème div à droite */
        text-align: right;
        padding-top: 1rem;
    } 
    .parameter-area--large-labels input[type=text] {
        font-size: 3rem;
        min-width: 99%;
    }
    .parameter-area--large-labels input[type=email] {
        font-size: 3rem;
        min-width: 99%;
    }
    .parameter-area--large-labels input[type=tel] {
        font-size: 3rem;
        min-width: 99%;
    }
    .parameter-area--large-labels select {
        font-size: 4rem;
        min-width: 20%;
    }
    .parameter-area--large-labels div {
        /*font-size: 20px;*/
        font-size: 3rem;
        /*border: 1px solid white;*/
        overflow: visible;
    }
   .main-menu-panel {
        display: none;
        background: rgba(0,0,0,0.8);
        width: 80%;
        transition: none;
        font-size: 3rem;
    }
    .main-menu>* {
        font-size: 4.5rem;
        gap: 5px;
    }
    .main-menu-container>*:first-child() {
        height: 5vh;
    }
    .main-menu-container>*:nth-child(0n+2) {
        height: 75vh;
    }
    .main-menu-container>*:last-child() {
        height: 15vh;
    }
    .main-menu>*:last-child {
        height: 30%;
    }
    .main-menu>*:last-child div {
        height: 100%;
    }
    .main-menu>div {
        height: 5rem;
    }
    .sub-menu {
        font-size: 4rem;
        width: 400px;
        left:250px; /* Tenir compte du margin et padding */
    }
    #menu-burger {
        position: fixed;
        bottom: 2rem;
        left: 2rem;
        z-index: 120;
        display: inline;
    }
    .navigation-bar {
        font-size: 3rem;
        height: 4rem;
    }
    .navigation-bar-page-data {
        background : white;
        border: 1px solid black;
        font-family: monospace;
    }
    
    .navigation-bar .ui-button {
        font-size: 3rem;
    }
    #additem {
        font-size: 42px;
    }
    .ui-button {
        font-size: 4rem;
        border: 0;
        line-height: 1.5;
        padding: 0 10px;
        
        text-align: center;
        color: #fff;
        text-shadow: 5px 5px 5px #000;
        border-radius: 16px;
        background-color: var(--defaultbutton-bg-color);
        background-image: var(--button-bg-image);
        box-shadow: var(--button-shadow);        
    }
    .ui-button.ui-button--cancel {/*TBC*/
        font-size: 4rem;
        border-radius: 16px;
    }
}


@media only screen and (height < 700px) {
    .main-menu-panel{
        &:hover {
            width: 350px;
        }
    }
    .main-menu>* {
        font-size: 16px;
    }
    .sub-menu {
        left: 300px; /* Tenir compte du margin et padding */
        width: 250px;
    }    
    .main-menu-logo {
        max-width: 20%;
        height: auto;
    }
}
    